// Main.h : Main event loop for the application.
//

/*
 * User-settable parameters.
 */

extern double key_sensitivity, mouse_sensitivity;
extern double camera_acceleration, camera_max_velocity;
extern double camera_clip_near, camera_clip_far, camera_frustum_size;

extern char mythpath[256];

extern int target_triangle_count;
extern double target_pixel_size;
extern int draw_scenery, use_texgen;
extern int morph_vertices, morph_msec;

/*
 * Global variables
 */

// The Myth tag database.
extern TagDatabase *myth_tags;

// The list of maps that can be selected in the Map Dialog.
extern int mapsel_num_entrypoints, mapsel_choice;
extern entrypoint **mapsel_entrypoint;

/*
 * Typedefs
 */

typedef float vec3f[3];
enum datamode {DATA_MYTHPLUGIN, DATA_FUNCTION};

/*
 * Entry points from the Windows wrapper.
 */

void user_init(void);      // Called before anything is done
void user_setup(void);     // Called once the window, GL bindings etc. are all established.
void user_redraw(void);
int user_idle(void);
void user_destroy(void);

/*
 * Internal function prototypes
 */

// Entrypoint comparison for building a plugin selection dialogue.
int entrypoint_sort_comparison(const void *ep1, const void *ep2);

void setup_view(void);
void calculate_camera_matrix(void);

/*
 * Read and write user settings
 */

void default_settings(void);
void read_settingsfile(void);
void write_settingsfile(void);
