// ObjeTag.cpp : Routines for class ObjeTag and supporting code.
//

#include "stdafx.h"


// Create a new tag.
ObjeTag::ObjeTag(MythPlugin *my_plugin, tagheader *header_struct)
  : Tag(my_plugin, header_struct)
{
}

// Read the scen data from disk.
void ObjeTag::read_data(void)
{
  // Seek the tag-file to the start of the tag's data.
  fseek(plugin->tagfile, header->offset, SEEK_SET);

  // Read the 64-byte obje data.
  myth_read_shorts(plugin->tagfile, 6, obje_header.unknown1);
  obje_header.scale_factor = myth_read_short(plugin->tagfile);
  myth_read_shorts(plugin->tagfile, 25, obje_header.unknown2);

  loaded_data = TRUE;
}

// Read the bulk mesh data (the big arrays) from disk.
void ObjeTag::load_bulk_data(void)
{
  // Do nothing.
  bulkdata_size = 0;
  loaded_bulk_data = TRUE;
}

// Free the big mesh arrays that we don't
// need any more (but keep the rest of the tag around).
void ObjeTag::free_bulk_data(void)
{
  // Do nothing.
}
